﻿using System;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;

namespace TelerikWpfApp1
{
    public class ViewModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public const int ITEM_COUNT = 20;

        private Container container;

        public ViewModel()
        {
            Initialize();
        }

        public ObservableCollection<string> Items { get; set; } = new ObservableCollection<string>();

        public Container Container
        {
            get { return container; }
            set
            {
                container = value;
                PropertyChanged?.Invoke(this, new PropertyChangedEventArgs("Container"));
            }
        }

        private void Initialize()
        {
            Random random = new Random();

            for (int i = 0; i < ITEM_COUNT; i++)
                Items.Add(random.Next(0, 10000).ToString());

            Container = new Container();

            //Container content generation
            Container.GetType().GetProperties().ToList().ForEach(p => p.SetValue(Container, random.Next(0, 10000).ToString()));
        }
    }

    public class Container
    {
        public string Test1 { get; set; }
        public string Test2 { get; set; }
        public string Test3 { get; set; }
        public string Test4 { get; set; }
        public string Test5 { get; set; }
        public string Test6 { get; set; }
        public string Test7 { get; set; }
        public string Test8 { get; set; }
        public string Test9 { get; set; }
        public string Test10 { get; set; }
        public string Test11 { get; set; }
        public string Test12 { get; set; }
        public string Test13 { get; set; }
        public string Test14 { get; set; }
        public string Test15 { get; set; }
        public string Test16 { get; set; }
        public string Test17 { get; set; }
        public string Test18 { get; set; }
        public string Test19 { get; set; }
        public string Test20 { get; set; }
    }
}
